Last Comment Bug 772046 - ASan builds broken by WebRTC (Linker relocation error)
: ASan builds broken by WebRTC (Linker relocation error)
Status: RESOLVED FIXED
[asan][asan-build-blocker][qa-]
: sec-want
Product: Core
Classification: Components
Component: WebRTC (show other bugs)
: Trunk
: x86_64 Linux
: -- critical (vote)
: ---
Assigned To: Rafael Ávila de Espíndola (:espindola) (not reading bugmail)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-09 05:56 PDT by Christian Holler (:decoder)
Modified: 2012-07-27 09:57 PDT (History)
7 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments

Description Christian Holler (:decoder) 2012-07-09 05:56:19 PDT
Some change that landed on mozilla-central between July 8, 4:10 AM PDT and July 9, 4:10 AM PDT broke the automated AdressSanitizer builds:

/usr/bin/ld: ../../media/webrtc/trunk/src/modules/modules_rtp_rtcp/rtp_rtcp/source/rtp_packet_history.o: relocation R_X86_64_PC32 against `_ZNSt6vectorIjSaIjEE14_M_fill_insertEN9__gnu_cxx17__normal_iteratorIPjS1_EEmRKj' can not be used when making a shared object; recompile with -fPIC


The full build log is here: http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/choller@mozilla.com-a51d661b6650/try-linux64/try-linux64-bm14-try1-build8272.txt.gz


@Randall: Ms2ger on IRC suggested that this is related to some change that you made recently, is that likely?
Comment 1 Randell Jesup [:jesup] 2012-07-09 07:17:50 PDT
Related to webrtc preffing on over the weekend, yes, but glandium thinks there's a missing file in config/system-headers.  Since all the ones included in rt_packet_history.cc or included from it seem to be normal (cstring/cstddef/map/assert), and it doesn't happen in normal builds, the suspicion is that ASan adds some headers(?)

Someone who knows ASan should look at this.
Comment 2 Rafael Ávila de Espíndola (:espindola) (not reading bugmail) 2012-07-09 07:28:56 PDT
I am unable to reproduce it locally without patching and try will not give me the patch. Can you add instructions on how to reproduce the problem to this bug.
Comment 3 Christian Holler (:decoder) 2012-07-09 07:32:47 PDT
Yea seems like try is having problems. The patch that the autobuild script pushes to try is here:

http://users.own-hero.net/~decoder/asan-try.patch
Comment 4 Mike Hommey [:glandium] 2012-07-09 07:53:54 PDT
Note, this could be a clang issue of some sort (not necessarily due to asan).
Comment 5 Rafael Ávila de Espíndola (:espindola) (not reading bugmail) 2012-07-10 12:12:37 PDT
ok, I am taking a look at it. The build is still going, but I can reproduce the relocations.
Comment 6 Christian Holler (:decoder) 2012-07-10 15:24:21 PDT
(In reply to Rafael Ávila de Espíndola (:espindola) from comment #5)
> ok, I am taking a look at it. The build is still going, but I can reproduce
> the relocations.

Thanks Rafael :) Meanwhile I modified the patch to use --disable-webrtc to keep the daily builds running, and that works fine for now.
Comment 7 Rafael Ávila de Espíndola (:espindola) (not reading bugmail) 2012-07-10 19:21:42 PDT
Thanks for the bug report. It does look like a clang issue. I think I fixed it in 160034. I am giving in some extra testing and will let you know when the new package is available on tooltool.
Comment 8 Rafael Ávila de Espíndola (:espindola) (not reading bugmail) 2012-07-13 20:37:14 PDT
Decoder, there is a new clang manifest in bug 772853. Would you mind trying it to see if it fixes the build for you?
Comment 9 Rafael Ávila de Espíndola (:espindola) (not reading bugmail) 2012-07-17 14:55:50 PDT
A new version of clang is at

https://hg.mozilla.org/integration/mozilla-inbound/rev/9f7ea93fb10a

Can you give it a try?
Comment 10 Christian Holler (:decoder) 2012-07-23 06:44:04 PDT
Thanks Rafael, this is fixed with the most recent clang version :)

Note You need to log in before you can comment on or make changes to this bug.